var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import classnames from 'classnames';
import i18n from 'ui-i18n';
import { isNil, pipe, prop } from 'ramda';
import { wrapInArrayIfNeeded } from '@reltio/mdm-sdk';
import CheckIcon from '@mui/icons-material/Check';
import MenuItem from '@mui/material/MenuItem';
import { MultipliableSelect } from '../../../MultipliableSelect';
import { findEntryByValue, flattenGroupedEntries } from './helpers';
import { useStyles } from './styles';
export var MENU_ITEM_OFFSET = 25;
export var GroupedDropDownEditor = function (_a) {
    var value = _a.value, entries = _a.entries, classes = _a.classes, otherProps = __rest(_a, ["value", "entries", "classes"]);
    var flattenedEntries = flattenGroupedEntries(entries);
    var selectedValues = isNil(value) ? [] : wrapInArrayIfNeeded(value);
    var styles = useStyles();
    return (React.createElement(MultipliableSelect, __assign({ MenuProps: {
            disableAutoFocusItem: true
        }, classes: __assign(__assign({}, classes), { root: classnames(styles.root, prop('root', classes)), icon: classnames(styles.icon, prop('icon', classes)) }) }, otherProps, { value: value, getValueLabel: pipe(findEntryByValue(flattenedEntries), prop('label')) }), flattenedEntries.length > 0 ? (flattenedEntries.map(function (_a, index) {
        var value = _a.value, label = _a.label, depth = _a.depth, isGroup = _a.isGroup;
        return (React.createElement(MenuItem, { key: index, disabled: isGroup, value: value, style: { paddingLeft: "".concat((depth + 1) * MENU_ITEM_OFFSET, "px") } },
            selectedValues.includes(value) && React.createElement(CheckIcon, { className: styles.checkIcon }),
            label || value.toString()));
    })) : (React.createElement(MenuItem, { className: styles.emptyLabel, disabled: true }, i18n.text('No results found')))));
};
